<?php
if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

class cms_model_torg{

	function __construct(){
        $this->inDB = cmsDatabase::getInstance();
	$this->config      = self::getConfig();
    }
	
	


	
	    public function getDefaultConfig() {

        $cfg = array(
					  'is_shop'=>1,
     'show_vendors'=>1,
	   'vip_enabled'=>0,
                    'vip_prolong'=>0,
                     'vip_max_days'=>30,
                     'vip_day_cost'=>5
	            );

        return $cfg;

    }
    
           public function getConfig() {

        $inCore = cmsCore::getInstance();

        $default_cfg = self::getDefaultConfig();
        $cfg         = $inCore->loadComponentConfig('torg');
        $cfg         = array_merge($default_cfg, $cfg);

        return $cfg;

    }

     // ============================================================================ //
// ============================================================================ //

    /**
     *    
     * @param int $user_id
     * @return int
     */
    public static function getTorgWallPoints($user_id){
        $inDB = cmsDatabase::getInstance();
        $sql = "SELECT SUM(points) as points,  SUM(points2) as points2,  SUM(points3) as points3
	FROM cms_torg_wall
	WHERE user_id = $user_id";
        $result = $inDB->query($sql);
        if ($inDB->num_rows($result)>0){ $wall_points = $inDB->fetch_assoc($result);}
	return $wall_points;
     }
    // ============================================================================ //
// ============================================================================ //

    /**
     *    
     * @param int $user_id
     * @return int
     */
    public static function getTorgKarma($user_id){
        $inDB = cmsDatabase::getInstance();
        $sql = "SELECT SUM(points) as karma FROM cms_torg_karma WHERE user_id = $user_id";
        $result = $inDB->query($sql);
        if ($inDB->num_rows($result)>0){ $data = $inDB->fetch_assoc($result); if ($data['karma']) {$karma = $data['karma']; } else { $karma = 0; } }
        return $karma;
    }

// ============================================================================ //
// ============================================================================ //

    /**
     *            html
     * @param int $user_id
     * @param bool $showtitle
     * @param bool $controls
     * @return html
     */
    public static function getTorgKarmaFormat($user_id, $showtitle=false, $controls=true){
        //calculate positive karma
        $inUser = cmsUser::getInstance();

        $karma = self::getTorgKarma($user_id);

        $plus = '';
        $minus = '';

        if ($inUser->id && $controls){
            if(usrCanKarma($user_id, $inUser->id)){
                $plus = '<a href="/users/karma/plus/'.$user_id.'/'.$inUser->id.'" onclick="plusUkarma(\''.$user_id.'\', \''.$inUser->id.'\'); return false;" title=" +"><img src="/components/users/images/karma_up.png" border="0" alt=" +"/></a>';
                $minus = '<a href="/users/karma/minus/'.$user_id.'/'.$inUser->id.'" onclick="minusUkarma(\''.$user_id.'\', \''.$inUser->id.'\'); return false;" title=" -"><img src="/components/users/images/karma_down.png" border="0" alt=" -"/></a>';
            }
        }

        $html = '<table cellpadding="2" cellspacing="0"><tr>';
            $html .= '<td style="color:green">'.$plus.'</td>';
            if($karma>0){
                $html .= '<td><span class="user_karma_point">+'.$karma.'</span></td>';
            } elseif ($karma<0){
                $html .= '<td><span class="user_karma_point">'.$karma.'</span></td>';
            } else {
                $html .= '<td><span class="user_karma_point">'.$karma.'</span></td>';
            }
            $html .= '<td style="color:red">'.$minus.'</td>';
        $html .= '</tr></table>';

        return $html;
    }

    
    
    
    
    
 

	    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     *      
     * @param string $plugin
     * @return float
     */
    public function loadTorgConfig($target, $user_id){
   
     
 $inDB = cmsDatabase::getInstance();
 $inCore = cmsCore::getInstance();
        $config = array();

        if (isset($this->torg_configs[$target])) { return $this->torg_configs[$target]; }

        $config_yaml = $inDB->get_field('cms_torg_config', "id='{$user_id}' AND target='{$target}'", 'config');

        $config = $inCore->yamlToArray($config_yaml);
	

        $this->cacheTorgConfig($target, $config, $user_id);

        return $config;

    }
	 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     *     
     * @param string $plugin_name
     * @param array $config
     * @return bool
     */
    public function saveTorgConfig($target, $config, $user_id) {

        $inDB = cmsDatabase::getInstance();
	 $inCore = cmsCore::getInstance();

        //    YAML
        $config_yaml   = $inCore->arrayToYaml($config);
$s = ($inDB->rows_count('cms_torg_config', "id=$user_id") ? true:false);					
if ($s) {
        //   
        $save  = "UPDATE cms_torg_config
                          SET config='{$config_yaml}'
                          WHERE target = '{$target}' AND id='{$user_id}'";
} else if (!$s){
$save= "INSERT INTO cms_torg_config (id, config, target)
VALUES ({$user_id}, '$config', '$target')";	
}

        $inDB->query($save);

        //  
        return true;

    }

    /**
     *       
     * @param string $component
     * @param array $config
     * @return boolean
     */
    public function cacheTorgConfig($target, $config, $user_id){
       $this->torg_configs[$target] = $config;
        return true;
    }	
	

public function ratingData($item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $sql = "SELECT *, IFNULL(AVG(points), 0) as rating, COUNT(id) as votes
            FROM cms_torg_ratings
            WHERE item_id = $item_id
            GROUP BY item_id";
    $result = $inDB->query($sql) ;
    if ($inDB->num_rows($result)){
        $data = $inDB->fetch_assoc($result);
    } else {
        $data['rating'] = 0;
        $data['votes'] = 0;
    }
    return $data;
}

function buildRating($rating){
    $inCore     = cmsCore::getInstance();
    $inDB       = cmsDatabase::getInstance();
    global $_LANG;
    $rating     = round($rating, 2);
    $html = '<a href="#" title="'.$_LANG['RATING'].': '.$rating.'">';
    for($r = 0; $r < 5; $r++){
        if (round($rating) > $r){
            $html .= '<img src="/images/ratings/starfull.gif" border="0" style="padding:0;border:0;margin:0" />';
        } else {
            $html .= '<img src="/images/ratings/starhalf.gif" border="0" style="padding:0;border:0;margin:0" />';
        }
    }
    $html .= '</a>';
    return $html;
}

public function alreadyVoted($item_id){
    $inCore = cmsCore::getInstance();
    $inDB   = cmsDatabase::getInstance();
    $ip     = $_SERVER['REMOTE_ADDR'];
    $sql    = "SELECT points FROM cms_torg_ratings WHERE item_id = $item_id AND ip = '$ip' LIMIT 1";
    $result = $inDB->query($sql) ;
    if ($inDB->num_rows($result)){
        $data = $inDB->fetch_assoc($result);
		
        return (int)$data['points'];
    }    
    return false;
}

public function ratingForm($ratingdata, $item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
	    $inUser = cmsUser::getInstance();
		$userid=$inUser->id;
		    $model = new cms_model_torg();
    global $_LANG;
    $html = '';
    $html .= '<form name="rateform" action="" method="POST"><div class="torg_detailrating"><table><tr>' ."\n";
    $html .= '<td width="70px">'."\n";
    $html .= '<strong>'.$_LANG['RATING'].':</strong> <span>'.round($ratingdata['rating'], 2).'</span>'."\n";
    $html .= '</td>'."\n";
    $html .= '<td width="100px" valign="middle">'."\n";
    $html .= $model->buildRating($ratingdata['rating'])."\n";
    $html .= '</td>'."\n";
    $html .= '<td width="50px">'."\n";
    $html .= ''.$_LANG['VOTES'].': '."\n";
    $html .= '</td>'."\n";
    $html .= '<td width="40" valign="middle">'."\n";
    $html .= '<span>'.$ratingdata['votes'].'</span>'."\n";
    $html .= '</td>'."\n";
	
	
	$userdata  = $inDB->get_field('cms_torg_items', "id='{$item_id}'", 'user_id');
if ($userdata==$userid) {} else {
   if($userid){
    $html .= '<td width="80px">'."\n";
    $html .= '<strong>'.$_LANG['YOUR_VOTE'].':</strong>'."\n";
    $html .= '</td>'."\n";

	
			 
    $html .= '<td width="" align=left> '."\n";
	
		 
    $myvote = $model->alreadyVoted($item_id);
    if (!$myvote){
	
        $html .= '<input type="hidden" name="rating" value="1"/>'."\n";
        $html .= '<input type="hidden" name="item_id" value="'.$item_id.'"/>'."\n";
		
	 
	
        $html .= '<select name="points" style="width:50px" onchange="document.rateform.submit();">'."\n";
        $html .= '<option value="-1"> -- </option>'."\n";
        for($p=1; $p<=5; $p++) { $html .= '<option value="'.$p.'">'.$p.'</option>'."\n"; }
        $html .= '</select>'."\n";

    } else {
        $html .= '<span>'.$myvote.'</span>';
    }
    $html .= '</td>'."\n";
 	}}	
    $html .= '</tr></table></div></form>'."\n";
    return $html;
}


public function stavkaData($item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
	
    $ssql = "SELECT *, IFNULL(MAX(points), 0) as stavka, COUNT(id) as stavka_votes FROM cms_torg_stavka WHERE item_id = '$item_id' group by item_id";
    $sresult = $inDB->query($ssql) ;
    if ($inDB->num_rows($sresult)){
        $stavka_data = $inDB->fetch_assoc($sresult);
	
    } else {
        $stavka_data['stavka'] = 0;
        $stavka_data['stavka_votes'] = 0;
    }
    return $stavka_data;
}

public function buildStavka($stavka){
    $inCore     = cmsCore::getInstance();
    $inDB       = cmsDatabase::getInstance();
    global $_LANG;
    $stavka     = round($stavka, 2);
    $html = ''.$stavka.'';
    return $html;
}

public function alreadyStavka($item_id){
    $inCore = cmsCore::getInstance();
    $inDB   = cmsDatabase::getInstance();
	$inUser = cmsUser::getInstance();
		$user_id = $inUser->id;
    //$ip     = $_SERVER['REMOTE_ADDR'];
     $ssql    = "SELECT IFNULL(MAX(points), 0) as points FROM cms_torg_stavka WHERE item_id = $item_id AND user_id = $user_id LIMIT 1";
    $sresult = $inDB->query($ssql) ;
    if ($inDB->num_rows($sresult)){
        $stavka_data = $inDB->fetch_assoc($sresult);
        return (int)$stavka_data['points'];
    }    
    return false;
}

public function AuPPS($au_ppsdate, $item_id){
		
$inDB = cmsDatabase::getInstance();

$au_ppsdate       = array();	
$au_ppsdate_sql = "SELECT
i.au_enddate,
a.pubdate as lastpps, DATE_ADD(a.pubdate, INTERVAL i.au_enddate HOUR) as ppsend
FROM cms_torg_stavka a
LEFT JOIN cms_torg_items i ON i.id = '{$item_id}'
WHERE a.item_id = '{$item_id}' ORDER BY a.pubdate LIMIT 1";

$au_ppsdatesql = $inDB->query($au_ppsdate_sql);
if ($inDB->num_rows($au_ppsdatesql)){
$au_ppsdate = $inDB->fetch_assoc($au_ppsdatesql);
$au_ppsdate['ppsend_f']  = cmsCore::dateformat($au_ppsdate['ppsend']);
$au_ppsdate['lastpps_f']  = cmsCore::dateformat($au_ppsdate['lastpps']);
return $au_ppsdate;  
}
return false;
}

public function stavkaForm($stavkadata, $item_id){
$inCore = cmsCore::getInstance();
$inDB = cmsDatabase::getInstance();
$inUser = cmsUser::getInstance();
$login = $inUser->login;
$nickname = $inUser->nickname;
$cfg = $inCore->loadComponentConfig('torg');	
$model = new cms_model_torg();
$au_ppsdate = $model->AuPPS($au_ppsdate, $item_id);
global $_LANG;
$html = '';

$ssql  = "SELECT IFNULL(MAX(points), 0) as maxstavka FROM cms_torg_stavka WHERE item_id = $item_id  LIMIT 1";
$sresult = $inDB->query($ssql) ;
$max_stavka = $inDB->fetch_assoc($sresult);
$maxstavka = $max_stavka['maxstavka'];

$sql  = "SELECT s.nickname, s.login, i.prodano, i.au_enddate, i.au_endtype
FROM cms_torg_stavka s
         LEFT JOIN cms_torg_items i ON i.id = $item_id
         WHERE s.item_id = $item_id AND s.points =  $maxstavka
         LIMIT 1 ";
$result = $inDB->query($sql) ;
$max_stavka_user = $inDB->fetch_assoc($result);



$sqlz  = "SELECT user_id,  au_interval, price_min FROM cms_torg_items WHERE id = $item_id";
$resultz = $inDB->query($sqlz) ;
$stavka_user = $inDB->fetch_assoc($resultz);
$ilogin=$inUser->id;
if ($ilogin){
 	
if ($max_stavka_user['prodano'] ==1) {} else {
if ($stavka_user['user_id']==$ilogin)	{ $html .= '';} else {
	
$mystavka = $model->alreadyStavka($item_id);	
if ($mystavka){
$html .= '<div style="padding-left:5px;text-align:right">  : '.$mystavka.' '.$cfg['price_val'].'</div>';
}

                        $date=date('Y-m-d H:i:s');
                        $au_enddate = ($max_stavka_user['au_endtype'] == 2 ? $au_ppsdate['ppsend'] : $max_stavka_user['au_enddate'].'');
                        $au_end = ($au_enddate < $date ? true : false);
			

			
if (!$au_end || !$max_stavka_user['au_enddate']) {
	
$html .= '<div><form name="stavkaform" action="" method="POST">';
$html .= '<input type="hidden" name="stavka" value="1"/>'."\n";
$html .= '<input type="hidden" name="login" value="'.$login.'"/>'."\n";
$html .= '<input type="hidden" name="nickname" value="'.$nickname.'"/>'."\n";
$html .= '<input type="hidden" name="item_id" value="'.$item_id.'"/>'."\n";
$html .= '<input type="hidden" name="maxstavka" value="'.$mystavka.'" />'."\n";

$minstavka = ($maxstavka ? $maxstavka : $stavka_user['price_min']);

$html .= '<input type="number" name="points"  id="int" class="points" min="'.$minstavka.'" step="'.$stavka_user['au_interval'].'"  value=""
title="   '.$minstavka.''.$cfg['price_val'].'    '.$stavka_user['au_interval'].''.$cfg['price_val'].'" > '.$cfg['price_val'].'.'."\n";
$_LANG['add_stavka'] = ($mystavka ? '  ' : $_LANG['add_stavka']);
$html .= '<input type="button" onclick="document.stavkaform.submit();" value="'.$_LANG['add_stavka'].'">'."\n";
 
$html .= '</form></div>'."\n";

}

}
}
}

else {$html .= ''.$_LANG['stavka_zareg'].'';}
if ($max_stavka['maxstavka']){
$html .= '<div class="stavki">'."\n";

$_LANG['add_stavka'] = ($mystavka ? '  ' : $_LANG['add_stavka']);

$html.=''.$no_stavka.'<b> :</b><br/><span>
<a href="/users/'.$max_stavka_user['login'].'">'.$max_stavka_user['nickname'].'</a>';
$html .= '- <b style="font-size:16px">'.$max_stavka['maxstavka'].' '.$cfg['price_val'].'.</b></span>';
$html .= '</div>'."\n";
}



 
$sqls    = "SELECT points, nickname, login FROM cms_torg_stavka WHERE item_id = $item_id ORDER BY points";
$results = $inDB->query($sqls) ;
if ($inDB->num_rows($results)){
$html .= '<div id="stavki"><div>';
while ( $users_stavka = $inDB->fetch_assoc($results)){
if ($max_stavka_user['login'] !== $users_stavka['login']) {
$html .= '<div class="stavki">
<a href="/users/'.$users_stavka['login'].'" style="text-decoration:none">'.$users_stavka['nickname'].'</a> - <b>'.$users_stavka['points'].' <span style="font-size:11px">'.$cfg['price_val'].'.</span></b>
</div>';
}
}
$html .= '</div></div>'."\n";
}
	
return $html;
}






public function ibuyData($item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $sql = "SELECT *, points as bayed, COUNT(id) as votes
            FROM cms_torg_ibuy
            WHERE item_id = '{$item_id}'
            GROUP BY item_id";
    $result = $inDB->query($sql) ;
    if ($inDB->num_rows($result)){
        $data = $inDB->fetch_assoc($result);
    } else {
	        $data['bayed'] = 0;
         $data['votes'] = 0;
    }
    return $data;
}

public function alreadyIbuy($item_id){
    $inCore = cmsCore::getInstance();
    $inDB   = cmsDatabase::getInstance();
		    $inUser = cmsUser::getInstance();
	$userid=$inUser->id;
    $sql    = "SELECT user_id FROM cms_torg_ibuy WHERE item_id = '{$item_id}' AND user_id = '{$userid}' LIMIT 1";
    $result = $inDB->query($sql) ;
    if ($inDB->num_rows($result)){
        $data = $inDB->fetch_assoc($result);
        return (int)$data['user_id'];
    }    
    return false;
}

public function ibuyForm($ibuydata, $item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
	    $inUser = cmsUser::getInstance();
$userid=$inUser->id;
$login = $inUser->login;
$nickname = $inUser->nickname;
$model = new cms_model_torg();
    global $_LANG;
    $html = '';
    $html .= '<div style="width:200px;margin:0 auto"><div style="padding:6px 10px 155px 10px;margin-top:25px">
	<div style="padding:10px 5px 20px 5px;font:bold 13px Arial;">     ?</div>
	<form name="ibuyform" action="" method="POST">' ."\n";
$userdata  = $inDB->get_field('cms_torg_items', "id=$item_id", 'user_id');

if ($userdata==$userid) {

} else {
    $mybuy = $model->alreadyIbuy($item_id);
      if (!$mybuy){
        $html .= '<input type="hidden" name="bayed" value="1"/>'."\n";
		        $html .= '<input type="hidden" name="ponts" value="1"/>'."\n";

        $html .= '<input type="hidden" name="item_id" value="'.$item_id.'"/>'."\n";
	      if($userid){
		       $html .= '<input type="button" onclick="document.ibuyform.submit();" value=" " style="font-size:14px;margin-bottom:20px">'."\n";
	       }
      } else {
        
      }
}	
    $html .= '</form>'."\n";
	
		 $sqls    = "SELECT points, nickname, login FROM cms_torg_ibuy WHERE item_id = $item_id";
    $results = $inDB->query($sqls) ;
    if ($inDB->num_rows($results)){
	    $html .= '';

         while ( $users_bayed = $inDB->fetch_assoc($results)){
 	       $html .= '<a href="/users/'.$users_bayed['login'].'" style="text-decoration:none;background:url(/templates/_default_/images/torg/icons/user.png) left no-repeat;padding:5px 5px 5px 18px;display:block;text-align:left;margin-right:5px;margin-left:5px;float:left">'.$users_bayed['nickname'].'</a>';
	      }
	
	  }
	  $html .= '<div style="clear:botch"></div></div></div>'."\n";
    return $html;
}


    public function isItemInCart($item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
        $session_id = session_id();
        $exists_id  = $inDB->get_field('cms_torg_cart', "session_id='{$session_id}' AND item_id='{$item_id}'", 'id');
        
        return $exists_id;

    }
public function shopRemoveFromCart($item_id=0){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();
	if (isset($inUser->id)){ $user_id = $inUser->id; } else { $user_id = 0; }	
	$sid = session_id();
	$sql = "DELETE FROM cms_torg_cart WHERE item_id = $item_id AND session_id='$sid'";	
	$rs = $inDB->query($sql) ;
	return true;
}

public function shopClearCart(){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();
		$sid = session_id();
	$sql = "DELETE FROM cms_torg_cart WHERE session_id='$sid'";	
	$rs = $inDB->query($sql) ;
	return true;
}

public function shopIsInCart($item_id=0){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();
	if (isset($inUser->id)){ $user_id = $inUser->id; } else { $user_id = 0; }	
	$sid = session_id();
	
	if ($user_id){ $user_sql = "(user_id=$user_id OR session_id='$sid')"; } else { $user_sql = "(user_id=0 AND session_id='$sid')"; }

	if ($item_id){        
		$isin = dbRowsCount('cms_torg_cart', "item_id = $item_id AND $user_sql");
	} else {        
		$isin = dbRowsCount('cms_torg_cart', "$user_sql");
	}

	return $isin;
}


public function shopCartLink(){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    global $_LANG;

    $model = new cms_model_torg();
	$items = $model->shopIsInCart();	
	$html = '';
		$html .= '<a id="shop_cartlink" href="/torg/viewcart.html">'.$_LANG['CART'];
		if ($items){
			$html .= ' ('.$items.')';
		}
		$html .= '</a>';
	return $html;
}

public function shopCheckCarts(){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
	$sql = "DELETE FROM cms_torg_cart WHERE user_id = 0 AND pubdate <= DATE_SUB(NOW(), INTERVAL 3 HOUR)";
	$inDB->query($sql) ;
	return true;
}

public function shopUpdateCart($itemcounts){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
	foreach($itemcounts as $id => $count){
		$sql = "UPDATE cms_torg_cart SET itemscount = $count WHERE id = $id";
		$inDB->query($sql) ;
	}
	return true;
}
	
	

public function prodanoData($item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    $sql = "SELECT prodano FROM cms_torg_items WHERE id = '{$item_id}'";
    $result = $inDB->query($sql) ;
    if ($inDB->num_rows($result)){
        $data = $inDB->fetch_assoc($result);
		
    } else {
        $data['prodano'] = 0;
	      
      
    }
   
    return $data;
}
public function buildProdano($prodano){
    $inCore     = cmsCore::getInstance();
    $inDB       = cmsDatabase::getInstance();
    global $_LANG;
    $prodano     = round($prodano, 2);
    $html = ''.$prodano.'';
    return $html;
}

public function alreadyProdano($item_id){
    $inCore = cmsCore::getInstance();
    $inDB   = cmsDatabase::getInstance();
    $inUser = cmsUser::getInstance();
		$user_id = $inUser->id;
    $sql    = "SELECT prodano, kolvo, archive FROM cms_torg_items WHERE id = '{$item_id}' AND user_id = '{$user_id}'";
    $result = $inDB->query($sql) ;
    if ($inDB->num_rows($result)){
        $data = $inDB->fetch_assoc($result);
	      return $data;
    }else{
       return false;
    }
}

public function prodanoForm($prodano, $item_id){
    $inCore = cmsCore::getInstance();
    $inDB = cmsDatabase::getInstance();
    global $_LANG;
			$model = new cms_model_torg();
    $myprodano = $model->alreadyProdano($item_id);
   
$html .= '<form name="prodanoform" action="" method="POST" style="display:inline;margin-left:10px">'.$_LANG['status'].': ' ."\n";
if ($myprodano['prodano']==1 || $myprodano['kolvo']==0 || $myprodano['archive']==1) $myprodano1 = 'selected="selected"';
elseif ($myprodano['prodano']==2) $myprodano2 = 'selected="selected"';
else $myprodano3 = 'selected="selected"';
$html .= '<input type="hidden" name="item_id" value="'.$item_id.'"/>'."\n";
$html .= '<select name="prodano"  onchange="document.prodanoform.submit();" style="font-size:14px">'."\n";
$html .= '<option value="1" '.$myprodano1.'> x &nbsp;'.$_LANG['prodan'].'</option>';
$html .= '<option value="2" '.$myprodano2.'> &#8226; &nbsp;'.$_LANG['rezerv'].'</option><option value="0" '.$myprodano3.'> &raquo; '.$_LANG['activ'].'</option>'."\n";
$html .= '</select>'."\n";
$html .= '</form>'."\n";

    return $html;
}




    public function getCommentTarget($target, $target_id) {

        $result = array();

        switch($target){

            case 'torg': $item            = $this->inDB->get_fields('cms_torg_items', "id={$target_id}", 'title');
                            if (!$item) { return false; }
                            $result['link']  = '/torg/item'.$target_id.'.html';
                            $result['title'] = $item['title'];
                            break;

        }

        return ($result ? $result : false);

    }


    public function getRewTarget($target, $target_id) {

        $result = array();

        switch($target){

            case 'torg': $item            = $this->inDB->get_fields('cms_torg_items', "id={$target_id}", 'title');
                            if (!$item) { return false; }
                            $result['link']  = '/torg/item'.$target_id.'.html';
                            $result['title'] = $item['title'];
                            break;

        }

        return ($result ? $result : false);

    }

/* ==================================================================================================== */
/* ==================================================================================================== */


/* ==================================================================================================== */
/* ==================================================================================================== */
	public function deleteItem($id){
        $inCore = cmsCore::getInstance();
        $imageurl = $this->getItemImageUrl($id);

        @chmod($_SERVER['DOCUMENT_ROOT']."/images/torg/$file", 0777);
        @chmod($_SERVER['DOCUMENT_ROOT']."/images/torg/small/'.$id.'/$file.jpg", 0777);
        @chmod($_SERVER['DOCUMENT_ROOT']."/images/torg/medium/'.$id.'/$file.jpg", 0777);

        @unlink($_SERVER['DOCUMENT_ROOT'].'/images/torg/'.$imageurl);
        @unlink($_SERVER['DOCUMENT_ROOT'].'/images/torg/small/'.$id.'/'.$imageurl.'');
        @unlink($_SERVER['DOCUMENT_ROOT'].'/images/torg/medium/'.$id.'/'.$imageurl.'');
        
        $this->inDB->query("DELETE FROM cms_torg_items WHERE id={$id}");
        $this->inDB->query("DELETE FROM cms_tags WHERE target='torg' AND item_id = {$id}");
        $this->inDB->query("DELETE FROM cms_torg_ratings WHERE item_id = {$id}");
		
	cmsActions::removeObjectLog('add_torg', $id);
		
        $inCore->deleteComments('torg', $id);

    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function updateItem($id, $item){
        $inCore = cmsCore::getInstance();
        $item = cmsCore::callEvent('UPDATE_torg_ITEM', $item);

        if ($item['file']){
            $item['imageurl'] = $item['file'];
        }

        if (!$item['is_moderate']){ $item['is_moderate']=0; }


        $sql = "UPDATE cms_torg_items
        SET title='{$item['title']}',
	category_id = '{$item['cat_id']}',
	art = '{$item['art']}',
        pubdate='{$item['pubdate']}',
        published='{$item['published']}',
        fieldsdata='{$item['fields']}',
        is_comments='{$item['is_comments']}',
        tags='{$item['tags']}',
        meta_desc='{$item['meta_desc']}',
        meta_keys='{$item['meta_keys']}',
        torg='{$item['torg']}',
        au='{$item['au']}',
	au_endtype='{$item['au_endtype']}',
	au_interval='{$item['au_interval']}',
	au_enddate='{$item['au_enddate']}',
        price='{$item['price']}',
	price_old='{$item['price_old']}',
        price2='{$item['price2']}',
	price_nds='{$item['price_nds']}',
        price2_nds='{$item['price2_nds']}',
        kolvo='{$item['kolvo']}',
        price_min='{$item['price_min']}',
        canmany='{$item['canmany']}',
        sostoyanie='{$item['sostoyanie']}',
        instant='{$item['instant']}',
        sale='{$item['sale']}',
        zakaz='{$item['zakaz']}',
        zakaz_dney='{$item['zakaz_dney']}',
        zakaz_predoplata='{$item['zakaz_predoplata']}',
        billing_buy='{$item['billing_buy']}',
        wm_buy='{$item['wm_buy']}',
        free='{$item['free']}',
        obmen='{$item['obmen']}',
        free_text='{$item['free_text']}',
        obmen_text='{$item['obmen_text']}',
	eltovar='{$item['eltovar']}',
        eltovar_text='{$item['eltovar_text']}',
        on_moderate='{$item['on_moderate']}'
                WHERE id = $id
                LIMIT 1";
        
        $this->inDB->query($sql) ;
		
         $item['id'] = $id;
	  if ($item['eltovar']) {    
	//     
	$inCore->includeFile('components/torg/model_eltovar.php');
	$model_eltovar = new cms_model_torg_eltovar();
        $model_eltovar->uploadItemFiles($id, $item['eltovar']);
	  }
	   
        cmsInsertTags($item['tags'], 'torg', $id);
          
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function renewItem($id){        
        cmsCore::callEvent('RENEW_torg_ITEM', $id);
        $sql = "UPDATE cms_torg_items SET pubdate = NOW() WHERE id = $id";
		$this->inDB->query($sql);
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function getItemImageUrl($id){
        $imageurl   = $this->inDB->get_field('cms_torg_items', "id={$id}", 'imageurl');
        $imageurl   = cmsCore::callEvent('GET_torg_ITEM_IMAGE', $imageurl);
        return $imageurl;
    }



	


/* ==================================================================================================== */
/* ==================================================================================================== */


	public function addItem($item){
        $inUser = cmsUser::getInstance();
 $inCore = cmsCore::getInstance();
        if (!isset($item['on_moderate'])) { $item['on_moderate'] = 0; }

        $item = cmsCore::callEvent('ADD_torg_ITEM', $item);
		    $cfg = $inCore->loadComponentConfig('torg');
		
$title=$item['title'];
$a1 = array("'<'","'>'","'\"'");  //   
$a2 = array('(',')','&quot;');  //    
$title=preg_replace($a1, $a2, $title);

$sql = "INSERT INTO cms_torg_items (
category_id,
art,
title,
pubdate,
published,
imageurl,
fieldsdata,
is_comments,
tags,
rating,
meta_desc,
meta_keys,
price,
price_old,
billing_buy,
wm_buy,
price2,
price_nds,
price2_nds,
kolvo,
canmany,
price_min,
torg,
au,
au_interval,
au_endtype,
au_enddate,
sostoyanie,
instant,
sale,
zakaz,
zakaz_dney,
zakaz_predoplata,
user_id,
free,
obmen,
free_text,
obmen_text,
eltovar,
eltovar_text,
filename,
filesize,
filedate,
on_moderate
)

VALUES (
'{$item['cat_id']}',
'{$item['art']}',
'{$title}',
'{$item['pubdate']}',
'{$item['published']}',
'{$item['file']}',
'{$item['fields']}',
{$item['is_comments']},
'{$item['tags']}',
0,
'{$item['meta_desc']}',
'{$item['meta_keys']}',
'{$item['price']}',
'{$item['price_old']}',
'{$item['billing_buy']}',
'{$item['wm_buy']}',
'{$item['price2']}',
'{$item['price_nds']}',
'{$item['price2_nds']}',
'{$item['kolvo']}',
{$item['canmany']},
'{$item['price_min']}',
'{$item['torg']}',
'{$item['au']}',
'{$item['au_interval']}',
'{$item['au_endtype']}',
'{$item['au_enddate']}',
'{$item['sostoyanie']}',
'{$item['instant']}',
'{$item['sale']}',
'{$item['zakaz']}',
'{$item['zakaz_dney']}',
'{$item['zakaz_predoplata']}',
{$inUser->id},
'{$item['free']}',
'{$item['obmen']}',
'{$item['free_text']}',
'{$item['obmen_text']}',
'{$item['eltovar']}',
'{$item['eltovar_text']}',
'{$item['filename']}',
'{$item['filesize']}',
'NOW()',
{$item['on_moderate']})";

$this->inDB->query($sql);
		
		
$item_id = dbLastId('cms_torg_items');
if ($item['eltovar']) {
//     
	$inCore->includeFile('components/torg/model_eltovar.php');
	$model_eltovar = new cms_model_torg_eltovar();
        $model_eltovar->uploadItemFiles($item_id, $item['eltovar']);
}
	
cmsInsertTags($item['tags'], 'torg', $item_id);

$userid=$inUser->id;
	
if($cfg['add_ratting']) {
$numm=$cfg['add_ratting_num'];	
//       	
$sql2 = "UPDATE cms_torg_users SET torg_rating = torg_rating + $numm WHERE id=$userid";
$this->inDB->query($sql2);
}
if($cfg['add_karma']) {
$numm=$cfg['add_karma_num'];		
//       	
$sql3 = "INSERT INTO cms_torg_karma (user_id, sender_id, points, senddate)
VALUES ('{$userid}','1','{$numm}','{$item['pubdate']}')";

$this->inDB->query($sql3);
}
        return $item_id;
    }



/* ==================================================================================================== */
/* ==================================================================================================== */

	public function copyItem($id, $copies){
        cmsCore::callEvent('COPY_torg_ITEM', $id);

        $sql = "SELECT * FROM cms_torg_items WHERE id = $id";
        $rs = $this->inDB->query($sql);
        if ($this->inDB->num_rows($rs)==1){
            $item = mysql_fetch_row($rs);
            for($c=1; $c<=$copies; $c++){
                //COPY ITEM
                $sql = "INSERT INTO cms_torg_items VALUES (";
                foreach($item as $key=>$value){
                    if ($key>0){ $sql .= "'$value'"; } else { $sql .= "''"; }
                    if ($key<sizeof($item)-1){ $sql .= ", "; } else { $sql .= ')'; }
                }
                $this->inDB->query($sql);
                //COPY ITEM TAGS
                $id = dbLastId('cms_torg_items');
                $sql = "SELECT * FROM cms_tags WHERE target='torg' AND item_id=".$item_id;
                $rst = $this->inDB->query($sql);
                if ($this->inDB->num_rows($rst)){
                    while ($itag = $this->inDB->fetch_assoc($rst)){
                        $sql = "INSERT INTO cms_tags VALUES ('', '{$itag['tag']}', 'torg', '$id')";
                        $this->inDB->query($sql);
                    }
                }
            }
        }
    }

/* ==================================================================================================== */
/* ==================================================================================================== */



	public function deleteDiscount($id){
        cmsCore::callEvent('DELETE_torg_DISCOUNT', $id);
        $sql = "DELETE FROM cms_torg_discount WHERE id = $id LIMIT 1";
        $this->inDB->query($sql) ;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function updateDiscount($id, $item){
        $item = cmsCore::callEvent('UPDATE_torg_DISCOUNT', $item);
        $sql = "UPDATE cms_torg_discount
                SET cat_id = '{$item['cat_id']}',
                    title = '{$item['title']}',
					    mailp = '{$item['mailp']}',
                    sign = '{$item['sign']}',
                    value = '{$item['value']}',
                    unit = '{$item['unit']}',
                    if_limit = {$item['if_limit']}
                WHERE id = $id
                LIMIT 1";
        $this->inDB->query($sql);
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function addDiscount($item){
        $item = cmsCore::callEvent('ADD_torg_DISCOUNT', $item);
        $sql = "INSERT INTO cms_torg_discount (title, mailp, cat_id, sign, value, unit, if_limit)
				VALUES ('{$item['title']}', {$item['mailp']}, {$item['cat_id']}, {$item['sign']}, '{$item['value']}', '{$item['unit']}', {$item['if_limit']})";
		$this->inDB->query($sql);
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function deleteCategory($id){
        $inCore = cmsCore::getInstance();
        cmsCore::callEvent('DELETE_torg_CAT', $id);
	    $inDB   = cmsDatabase::getInstance();	
		
        $sql = "SELECT id FROM cms_torg_items WHERE category_id = $id";
        $result = dbQuery($sql) ;
        if ($this->inDB->num_rows($result)){
            while($item = $this->inDB->fetch_assoc($result)){
                $this->deleteItem($item['id']);
            }
        }
		$f_icon = $inDB->get_field('cms_torg_cats', "id = '$id'", 'icon');
			//DELETE ALBUM
			dbDeleteNS('cms_torg_cats', $id);
			if(file_exists(PATH.'/upload/torg/cat_icons/'.$f_icon)){
				@chmod(PATH.'/upload/torg/cat_icons/'.$f_icon, 0777);
				@unlink(PATH.'/upload/torg/cat_icons/'.$f_icon);
			}
        $ns = $inCore->nestedSetsInit('cms_torg_cats');
        $ns->DeleteNode($id);
	
        return true;
    }
/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getCategories($only_published=true, $parent_id=0) {

        $cats       = array();
        $pub_where  = $only_published ? 'AND published=1' : '';

        if (!$parent_id) { 
            $parent_where = 'parent_id > 0'; 
        }

        if ($parent_id) {
            $parent = $this->inDB->get_fields('cms_torg_cats', "id={$parent_id}", 'NSLeft, NSRight');
            $parent_where = "NSLeft >= {$parent['NSLeft']} AND NSRight <= {$parent['NSRight']}";
        }

        $sql  = "SELECT *
                 FROM cms_torg_cats
                 WHERE {$parent_where} {$pub_where}
                 ORDER BY NSLeft";

        $res  = $this->inDB->query($sql);

        if ($this->inDB->num_rows($res)){
            while($cat = $this->inDB->fetch_assoc($res)){
                $cats[] = $cat;
            }
        }

        return $cats;

    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function updateCategory($id, $cat){
        $inCore = cmsCore::getInstance();
        
        $cat = cmsCore::callEvent('UPDATE_torg_CAT', $cat);

        $ns = $inCore->nestedSetsInit('cms_torg_cats');
        $ns->MoveNode($id, $cat['parent_id']);

        $sql = "UPDATE cms_torg_cats
                SET parent_id = '{$cat['parent_id']}',
				 
                    title = '{$cat['title']}',
                    description = '{$cat['description']}',
                    published = '{$cat['published']}',
                    fieldsstruct = '{$cat['fields']}',
                    view_type = '{$cat['view_type']}',
                    fields_show = '{$cat['fields_show']}',
                    showmore = '{$cat['showmore']}',
                    perpage = '{$cat['perpage']}',
                    showtags = '{$cat['showtags']}',
                    showsort = '{$cat['showsort']}',
                    is_ratings = '{$cat['is_ratings']}',
                    orderby = '{$cat['orderby']}',
                    orderto = '{$cat['orderto']}',
		 showabc = '{$cat['showabc']}',
                    shownew = '{$cat['shownew']}',
                    newint = '{$cat['newint']}',
                    filters = '{$cat['filters']}',
                    is_public = '{$cat['is_public']}',
                    can_edit = '{$cat['can_edit']}',
		           elcat = '{$cat['elcat']}',
		     icon='{$cat['icon']}'
                WHERE id = $id
                LIMIT 1";
        $this->inDB->query($sql);
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

	public function addCategory($cat){

        $inCore = cmsCore::getInstance();
        $cat    = cmsCore::callEvent('ADD_torg_CAT', $cat);

        $ns = $inCore->nestedSetsInit('cms_torg_cats');
		$cat['id'] = $ns->AddNode($cat['parent_id']);

        $sql = "UPDATE cms_torg_cats
                SET parent_id = '{$cat['parent_id']}',
                    title = '{$cat['title']}',
                    description = '{$cat['description']}',
                    published = '{$cat['published']}',
                    fieldsstruct = '{$cat['fields']}',
                    view_type = '{$cat['view_type']}',
                    fields_show = '{$cat['fields_show']}',
                    showmore = '{$cat['showmore']}',
                    perpage = '{$cat['perpage']}',
                    showtags = '{$cat['showtags']}',
                    showsort = '{$cat['showsort']}',
                    is_ratings = '{$cat['is_ratings']}',
                    orderby = '{$cat['orderby']}',
                    orderto = '{$cat['orderto']}',
                    showabc = '{$cat['showabc']}',
                    shownew = '{$cat['shownew']}',
                    newint = '{$cat['newint']}',
                    filters = '{$cat['filters']}',
                    is_public = '{$cat['is_public']}',
                    can_edit = '{$cat['can_edit']}',
		        elcat = '{$cat['elcat']}',
		    icon='{$cat['icon']}'
                WHERE id = {$cat['id']}
                LIMIT 1";
        $this->inDB->query($sql);

        return $cat['id'];
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function copyCategory($id, $copies){
        cmsCore::callEvent('COPY_torg_CAT', $id);
        $sql = "SELECT * FROM cms_torg_cats WHERE id = $id";
        $rs = $this->inDB->query($sql) ;
        if ($this->inDB->num_rows($rs)==1){
            $item = mysql_fetch_row($rs);
            for($c=1; $c<=$copies; $c++){
                $sql = "INSERT INTO cms_torg_cats VALUES (";
                foreach($item as $key=>$value){
                    if ($key>0){ $sql .= "'$value'"; } else { $sql .= "''"; }
                    if ($key<sizeof($item)-1){ $sql .= ", "; } else { $sql .= ')'; }
                }
                $this->inDB->query($sql);
            }
        }
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getCategoryPath($left_key, $right_key) {

        $path = array();

        $sql = "SELECT id, title, NSLevel
                FROM cms_torg_cats
                WHERE NSLeft <= $left_key AND NSRight >= $right_key AND parent_id > 0
                ORDER BY NSLeft";

        $result = $this->inDB->query($sql);

        if (!$this->inDB->num_rows($result)) { return false; }

        while($cat = $this->inDB->fetch_assoc($result)){
            $path[] = $cat;
        }

        return $path;

    }

    public function getCategory($id) {
        return $this->inDB->get_fields('cms_torg_cats', "id={$id}", '*');
    }
	/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getRootCategory() {
        $root_id = $this->inDB->get_field('cms_torg_cats', "parent_id=0", 'id');
        return $this->getCategory($root_id);
    }




    public function reorder($table, $cat_field, $item_field) {

        $sql = "SELECT {$cat_field} FROM {$table} GROUP BY {$cat_field}";
        $res = $this->inDB->query($sql);

        while($r = $this->inDB->fetch_assoc($res)){

            $ord = 1;

            $sql2 = "SELECT {$item_field} 
                     FROM {$table}
                     WHERE {$cat_field} = {$r[$cat_field]}
                     ORDER BY ordering";

            $res2 = $this->inDB->query($sql2);

            while($r2 = $this->inDB->fetch_assoc($res2)){
                $this->inDB->query("UPDATE {$table} SET ordering = {$ord} WHERE {$item_field}={$r2[$item_field]} AND {$cat_field}={$r[$cat_field]}");
                $ord++;
            }

        }

        return true;

    }


/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getSubCats($parent_id, $left_key, $right_key) {

        $subcats=array();

        $sql = "SELECT cat.*, IFNULL(COUNT(con.id), 0) as content_count
                FROM cms_torg_cats cat
                LEFT JOIN cms_torg_items con ON con.category_id = cat.id AND con.published = 1
                WHERE (cat.parent_id=$parent_id) AND cat.published = 1
                GROUP BY cat.id";

        $result = $this->inDB->query($sql);

        if (!$this->inDB->num_rows($result)) { return false; }

        while($subcat = $this->inDB->fetch_assoc($result)){

            $count_sql = "SELECT con.id
                          FROM cms_torg_items con, cms_torg_cats cat
                          WHERE con.category_id = cat.id AND (cat.NSLeft >= {$subcat['NSLeft']} AND cat.NSRight <= {$subcat['NSRight']}) AND con.published = 1";

            $count_result = $this->inDB->query($count_sql);

            $subcat['content_count'] = $this->inDB->num_rows($count_result);

            $subcats[] = $subcat;

        }

        $subcats = cmsCore::callEvent('GET_torg_SUBCATS', $subcats);

        return $subcats;

    }

	
	/* ==================================================================================================== */
/* ==================================================================================================== */

    public function addToCart($item_id, $qty=1, $itemscount) {
 $inUser = cmsUser::getInstance();
 $user_id=$inUser->id;
        $session_id = session_id();


        $exists_id  = $this->inDB->get_field('cms_torg_cart', "session_id='{$session_id}' AND item_id='{$item_id}'", 'id');

        if (!$exists_id){

            $sql = "INSERT INTO cms_torg_cart (`session_id`, `item_id`, `user_id`, `qty`, `itemscount`, `pubdate`)
                    VALUES ('{$session_id}', '{$item_id}', '{$user_id}', '{$qty}', '{$itemscount}', NOW())";

        } else {

            $sql = "UPDATE cms_torg_cart SET qty = '{$qty}' WHERE id = {$exists_id} LIMIT 1";

        }

        $this->inDB->query($sql);

        return true;

    }

    public function deleteFromCart($cart_item_id){

        $this->inDB->query("DELETE FROM cms_torg_cart WHERE id = '{$cart_item_id}' LIMIT 1");
        
        return true;

    }
   


/* ==================================================================================================== */
/* ==================================================================================================== */

    public function setCategoryAccess($id, $showfor_list){

        $this->clearCategoryAccess($id);

        if (!sizeof($showfor_list)){ return true; }

        foreach ($showfor_list as $key=>$value){
            $sql = "INSERT INTO cms_torg_cats_access (cat_id, group_id)
                    VALUES ($id, $value)";
            $this->inDB->query($sql);
        }

        return true;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function clearCategoryAccess($id){

        $sql = "DELETE FROM cms_torg_cats_access WHERE cat_id = $id";

        $this->inDB->query($sql);

        return true;
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function checkCategoryAccess($cat_id, $cat_public, $group_id) {
        return ($cat_public && $this->inDB->rows_count('cms_torg_cats_access', "cat_id='{$cat_id}' AND group_id='{$group_id}'", 1));
    }

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function addModerationItem($item_id) {

    }
	
	
	    

	
	

/* ==================================================================================================== */
/* ==================================================================================================== */

    public function getCartItems() {
   $inUser = cmsUser::getInstance();
        $session_id = session_id();
        $items      = array();
  $sql   = "SELECT   items.title as title,
                                items.price as price,
				items.imageurl,
                                items.kolvo as qty,
                                cart.itemscount as cart_itemscount,
                                cart.item_id as item_id,
                                cart.id as cart_id
                        
                        FROM    cms_torg_cart cart, cms_torg_items items
      
                        WHERE   cart.session_id = '{$session_id}' AND
                                cart.item_id = items.id";

$sql_result = $this->inDB->query($sql);
if (!$this->inDB->num_rows($sql_result)){
return false;
}
if ($this->inDB->num_rows($sql_result)){	
while ($item = $this->inDB->fetch_assoc($sql_result)){
$item['link'] = '/torg/item'.$item['item_id'].'.html';
$item['image']   = (file_exists($_SERVER['DOCUMENT_ROOT'].'/images/torg/small/'.$item['item_id'].'/'.$item['imageurl'].'')) ? '<img src="/images/torg/small/'.$item['item_id'].'/'.$item['imageurl'].'"/>' : '';
$items[] = $item;
}
}	
foreach($items as $key=>$item){
$items[$key]['totalprice'] = round($item['price']*$item['cart_itemscount'], 2);
}
foreach($items as $key=>$item){
$items[$key]['totalsumm'] = round($item['price']*$item['cart_itemscount'], 2);
}
return $items;

    }




// VIP 

    public function whereVip($flag) {
        $this->where("i.is_vip = $flag");
    }

    public function setVip($id, $days){

        //   VIP      ,
        //     VIP  
        $sql = "UPDATE cms_torg_items
                SET is_vip = 1, vipdate = DATE_ADD(NOW(), INTERVAL {$days} DAY)
                WHERE id='{$id}' AND is_vip=0
                LIMIT 1";

        $this->inDB->query($sql);

        //    VIP,  VIP-  
        $sql = "UPDATE cms_torg_items
                SET vipdate = DATE_ADD(vipdate, INTERVAL {$days} DAY)
                WHERE id='{$id}' AND is_vip=1
                LIMIT 1";
                
        $this->inDB->query($sql);

        return true;

    }

    public function clearOldVips() {

        $this->inDB->query("UPDATE cms_torg_items SET is_vip=0 WHERE DATE(vipdate) <= CURRENT_DATE");

        return true;

    }
    
    
    public function oplata($item_id, $item_price, $prodavec_id){
  	$inUser = cmsUser::getInstance();
		$user_id = $inUser->id;
     $sql = "UPDATE cms_users
                SET balance = balance - {$item_price}
                WHERE id='{$user_id}'
                LIMIT 1";
     $this->inDB->query($sql);
     
     $sql = "UPDATE cms_users
                SET balance = balance + {$item_price}
                WHERE id='{$prodavec_id}'
                LIMIT 1";
     $this->inDB->query($sql);
 
    return true;
    }




function buildWallRating($rating){
    $inCore     = cmsCore::getInstance();
    $inDB       = cmsDatabase::getInstance();
    global $_LANG;
    $rating     = round($rating, 2);
    $html = '<a href="#" title="'.$_LANG['RATING'].': '.$rating.'" style="cursor:default">';
    for($r = 0; $r < 5; $r++){
        if (round($rating) > $r){
            $html .= '<img src="/components/torg/js/raty/img/star-on.png" border="0" />';
        } else {
            $html .= '<img src="/components/torg/js/raty/img/star-off.png" border="0" />';
        }
    }
    $html .= '</a>';
    return $html;
}
 /**    
     *  html  
     * @param int $selected
     * @param array $exclude
     * @return html
     */
	 
  public static function getTorgWall($user_id, $usertype='user', $page=1, $clubUserIsRole=0, $clubUserIsAdmin=0){

        $inDB       = cmsDatabase::getInstance();
        $inCore     = cmsCore::getInstance();
         $inUser = cmsUser::getInstance();
		$inCore->loadLanguage('components/users');
        global $_LANG;
        $myprofile  = false;

        $perpage    = 2;

		switch ($usertype){
			case 'user': $myprofile = ($inUser->id == $user_id || $inUser->is_admin);  break;
            			 $myprofile = ($clubUserIsRole || $clubUserIsAdmin || $inUser->is_admin); break;
			default: $myprofile = $inUser->is_admin;
        }

        $records = array();

        $pagebar = '';

        //       
        $total = $inDB->rows_count('cms_torg_wall', "user_id = $user_id AND usertype = '$usertype'");
        $pages = ceil($total / $perpage);
        
        if ($total){
            //    
            $sql = "SELECT w.*, g.gender, g.imageurl, u.nickname as author, u.login as author_login, u.is_deleted, w.pubdate,
	            i.title as item_title
                    FROM cms_torg_wall w
		    
					INNER JOIN cms_users u ON u.id = w.author_id
					INNER JOIN cms_user_profiles g ON g.user_id = u.id
						LEFT JOIN cms_torg_items i ON i.id = w.item_id
                    WHERE w.user_id = $user_id AND w.usertype = '$usertype'
                    ORDER BY w.pubdate DESC
                    LIMIT ".(($page-1)*$perpage).", $perpage";

            $result     = $inDB->query($sql);

			if (!function_exists('usrImageNOdb')){
            $inCore->includeFile('components/users/includes/usercore.php');
			}

            while($record = $inDB->fetch_assoc($result)){
                $record['is_today'] = time() - strtotime($record['pubdate']) < 86400;
				$record['fpubdate'] = $record['is_today'] ? $inCore->dateDiffNow($record['pubdate']) : $inCore->dateFormat($record['pubdate']);
                $record['avatar']   = usrImageNOdb($record['author_id'], 'small', $record['imageurl'], $record['is_deleted']);
		      $record['rating'] = self::buildWallRating($record['points']);
		      $record['rating2'] = self::buildWallRating($record['points2']);
		      $record['rating3'] = self::buildWallRating($record['points3']);
                $records[]          = $record;
            }

            $records = cmsCore::callEvent('GET_WALL_POSTS', $records);

            if ($pages>1){
                $pagebar = cmsPage::getPagebar($total, $page, $perpage, 'javascript:wallPage(%page%)');
            }
        }

        ob_start();

        $smarty = $inCore->initSmarty('components', 'com_torg_wall.tpl');

        $smarty->assign('records', $records);
        $smarty->assign('user_id', $inUser->id);
        $smarty->assign('wall_user_id', $user_id);
        $smarty->assign('myprofile', $myprofile);
        $smarty->assign('usertype', $usertype);
        $smarty->assign('pages', $pages);
        $smarty->assign('page', $page);
        $smarty->assign('total', $total);
	
        $smarty->assign('pagebar', $pagebar);

        $smarty->display('com_torg_wall.tpl');

        return ob_get_clean();
    }

// ============================================================================ //
// ============================================================================ //

    /**    
     *  html  "  "
     * @param int $user_id
     * @param string $usertype
     * @return html
     */
  public static function getTorgAddWall($user_id, $usertype='user'){
    $inDB       = cmsDatabase::getInstance();
        $inCore     = cmsCore::getInstance();

      $my_id      = cmsUser::getInstance()->id;

        $bb_toolbar = cmsPage::getBBCodeToolbar('message', true, 'users');
        $smilies    = cmsPage::getSmilesPanel('message');
	
$sql_p = "SELECT *
			FROM cms_user_zakazi
			WHERE to_id={$user_id} AND opla4en=1 AND otziv=0 ORDER BY id";	
$result_up = $inDB->query($sql_p);
if ($inDB->num_rows($result_up)>0){
$ups = array();
while($up = $inDB->fetch_assoc($result_up)){
$ups[] = $up;
}
}

        ob_start();

        $smarty = $inCore->initSmarty('components', 'com_torg_addwall.tpl');

        $smarty->assign('user_id', $user_id);
        $smarty->assign('usertype', $usertype);
        $smarty->assign('my_id', $my_id);
	
	$smarty->assign('zakazi', $ups);
	
        $smarty->assign('bb_toolbar', $bb_toolbar);
    	$smarty->assign('smilies', $smilies);

        $smarty->display('com_torg_addwall.tpl');

        return ob_get_clean();
        
    }
	
// ============================================================================ //
// ============================================================================ //



    //    //////////////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     * 
     */
    public function includeRew(){
        include_once PATH."/components/rew/frontend.php";
    }
    
    


    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     *       
     * @param string $target - 
     * @param string $component - 
     * @param string $title -    . ( "")
     */
    public function registerRewTarget($target, $component, $title) {

        $inDB = cmsDatabase::getInstance();

        $sql  = "INSERT INTO cms_torg_rew_targets (target, component, title)
                 VALUES ('$target', '$component', '$title')";

        $inDB->query($sql);

        return true;

    }

    public function getRewTargets() {

        $inDB = cmsDatabase::getInstance();

        $targets = $inDB->get_table('cms_torg_rew_targets', 'id>0', '*');

        return $targets;

    }

    /**
     *      
     * @param string $target
     * @param int $target_id
     * @return boolean
     */
    public function deleteRew($target, $target_id){

        $inDB = cmsDatabase::getInstance();

		$comments = $inDB->get_table('cms_torg_rew', "target='{$target}' AND target_id='{$target_id}'", 'id');

        if ($comments){

            foreach($comments as $comment){
                cmsActions::removeObjectLog('add_torg_rew', $comment['id']);
            }
			
        $sql  = "DELETE FROM cms_torg_rew WHERE target='{$target}' AND target_id='{$target_id}'";

        $inDB->query($sql);

        }

        return true;

    }

    /**
     *      
     * @param string $target
     * @param int $target_id
     * @return int
     */
    public function getRewCount($target, $target_id){
        $inDB = cmsDatabase::getInstance();
        if ($this->isComponentInstalled('rew')){
            $sql = "SELECT id FROM cms_torg_rew WHERE target = '$target' AND target_id = '$target_id' AND published = 1";
            $result = $inDB->query($sql) ;
            return $inDB->num_rows($result);
        } else { return 0; }
    }



    public function addBasicPhoto($item_id, $filename){

        $this->inDB->query( "UPDATE cms_torg_items
                            SET imageurl = '{$filename}'
                            WHERE id = '{$item_id}'");


    }
	
	 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     *        
     * @param string $access_type
     * @return bool
     */
    public function isTorgUserCan($access_type){ //$access_type like "comments/delete" or "photo/edit"
        $inDB = cmsDatabase::getInstance();
        $inUser = cmsUser::getInstance();

	      
        $do_access = false;

        if ($inUser->id) {
	 
            $group_id = $inDB->get_fields('cms_torg_users', 'id='.$inUser->id, 'group_id');
            $group_id = $group_id['group_id'];
            if ($inUser->is_admin){
                return true;
            }
            if (in_array($access_type, $_SESSION['user']['access'])){
                $do_access = true;
            }
        }
        else { $group_id = cmsUser::getGuestGroupId(); }

        if (!$do_access) {
            if ($group_id > 0) {
                $sql = "SELECT access FROM cms_torg_user_groups WHERE id = $group_id LIMIT 1";
            }
	    
	    

            $result = $inDB->query($sql) ;

            if ($inDB->num_rows($result)){
                $ac = $inDB->fetch_assoc($result);
                $access_str = $ac['access'];

                $access = str_replace(', ', ',', $access_str);
                $access = explode(',', $access);

                if (in_array($access_type, $access)){
                    $do_access = true;
                }
            }
        }

        return $do_access;
    }
    
    
    
    
    
    
    
    
 public function isTorgUserCans($access_type, $group_id){ //$access_type like "comments/delete" or "photo/edit"
        $inDB = cmsDatabase::getInstance();
        $inUser = cmsUser::getInstance();

	 
    $sql = "SELECT * FROM cms_torg_user_groups WHERE id = $group_id LIMIT 1";
					 $result = $inDB->query($sql) ;
					 if ($inDB->num_rows($result)){
						$mod = $inDB->fetch_assoc($result);
					 }
      
if(isset($mod['access'])){
		$mod['access'] = str_replace(', ', ',', $mod['access']);
		$mod['access'] = explode(',', $mod['access']);
	}
	if (in_array($access_type, $mod['access'])) {
        return true;
	}
    }
    
    
     
  public function hideEmail($email)
{
$character_set = '+-.0123456789@ABCDEFGHIJKLMNOPQRSTUVWXYZ_abcdefghijklmnopqrstuvwxyz';
$key = str_shuffle($character_set);
$cipher_text = '';
$id = 'e'.rand(1,999999999);
for ($i=0;$i<strlen($email);$i+=1) $cipher_text.= $key[strpos($character_set,$email[$i])];
$script = 'var a="'.$key.'";var b=a.split("").sort().join("");var c="'.$cipher_text.'";var d="";';
$script.= 'for(var e=0;e<c.length;e++)d+=b.charAt(a.indexOf(c.charAt(e)));';
$script.= 'document.getElementById("'.$id.'").innerHTML="<a href=\\"mailto:"+d+"\\">"+d+"</a>"';
$script = "eval(\"".str_replace(array("\\",'"'),array("\\\\",'\"'), $script)."\")";
$script = '<script type="text/javascript">/*<![CDATA[*/'.$script.'/*]]>*/</script>';
return '<span style="display:inline-block;margin-left:0" id="'.$id.'">[javascript protected email address]</span>'.$script;
} 
	
}
