<?php
function mod_torg_cart($module_id){

    $inCore     = cmsCore::getInstance();
    $inDB       = cmsDatabase::getInstance();
    $inPage     = cmsPage::getInstance();

    $inCore->loadModel('torg');
    $model = new cms_model_torg();


    $cfg        = $inCore->loadModuleConfig($module_id);
    $torg_cfg   = $inCore->loadComponentConfig('torg');

    if (!isset($cfg['showtype'])) {  $cfg['showtype'] = 'list';  }
    if (!isset($cfg['showqty']))  {  $cfg['showqty']  = 1;       }
    if (!isset($cfg['autohide'])) {  $cfg['autohide'] = 0;       }

    $items = $model->getCartItems();

    if (!$items && $cfg['autohide']) { return false; }

    $totalsumm = 0;

    foreach($items as $item){
        $totalsumm += ($item['price'] * $item['cart_itemscount']);
    }

    $smarty = $inCore->initSmarty('modules', 'mod_torg_cart.tpl');
    $smarty->assign('cfg', $cfg);
    $smarty->assign('torg_cfg', $torg_cfg);
    $smarty->assign('items', $items);
    $smarty->assign('items_count', sizeof($items));
    $smarty->assign('totalsumm', round($totalsumm, 2));
    $smarty->display('mod_torg_cart.tpl');

    return true;

}

	
	
	
?>